


#define		CZAS_IDLE	  30*130		// Czas do upienia kostki:  30 sekund x 130Hz
#define		CZAS_POWDWN	4*60*130		// Czas do wyaczenia kostki: 4 minuty x 130Hz

#define		CZAS_2KOLORY   1*130		// Czas wywietlania kadego koloru w trybie 2 kolory (sekundy x 130Hz)


/********************************************************************************/
/*																				*/
/********************************************************************************/
#define	uchar	unsigned char
#define	byte	unsigned char
#define	uint	unsigned int
#define	word	unsigned int
#define	ulong	unsigned long
#define	dword	unsigned long
#define	FALSE	0
#define	TRUE	1

#define	NONE		-1
#define	PARITYERR	-2
#define	FRAMEERR	-3
#define	OVERRUNERR	-4

#define	CRLF	"\r\n"
#define	CR		'\r'
#define	LF		'\n'
#define	ESC		0x2B
#define	EXIT	ESC

#include <avr/io.h>									// IO
#include <stdio.h>									//
#include <avr/sfr_defs.h>							// SFR, _BV(bit)
#include <avr/pgmspace.h>							// Flash
#define  CODE PROGMEM
#include <avr/interrupt.h>							// wektory IRQ
#include <avr/wdt.h> 								// WDG
#include <avr/eeprom.h>								// Eeprom
#include <string.h>									// Stringi
#include <compat/deprecated.h>						// sbi, cbi, inb, outb, outp
#define  ebi(port,bit) ( port ^= (1 << (bit)))		// Negowanie bitu na porcie
//#include <util/setbaud.h>							// Uart 0
//#include "include/setbaud1.h"						// Uart 1
#include <util/delay.h>
//#include <util/crc16.h>							// Crc16, Xmodem, Dallas
#include <avr/fuse.h>
#define NOINIT __attribute__ ((section(".noinit")))
#define nop()	__asm__ __volatile__( "nop" )		// Wstawia rozkaz NOP do kodu
#include <avr/sleep.h>
#include <avr/power.h>




/********************************************************************************/
/*																				*/
/********************************************************************************/
#define	SetA0	PORTB |=  (1<<PB7)
#define	ClrA0	PORTB &= ~(1<<PB7)
#define	SetA1	PORTD |=  (1<<PD5)
#define	ClrA1	PORTD &= ~(1<<PD5)
#define	SetA2	PORTD |=  (1<<PD6)
#define	ClrA2	PORTD &= ~(1<<PD6)
#define	SetA3	PORTD |=  (1<<PD4)
#define	ClrA3	PORTD &= ~(1<<PD4)
#define	SetA4	PORTC |=  (1<<PC4)
#define	ClrA4	PORTC &= ~(1<<PC4)
#define	SetA5	PORTB |=  (1<<PB6)
#define	ClrA5	PORTB &= ~(1<<PB6)
#define	SetA6	PORTB |=  (1<<PB0)
#define	ClrA6	PORTB &= ~(1<<PB0)

#define	SetKR	PORTB |=  (1<<PB1)
#define	ClrKR	PORTB &= ~(1<<PB1)
#define	SetKG	PORTB |=  (1<<PB2)
#define	ClrKG	PORTB &= ~(1<<PB2)
#define	SetKB	PORTB |=  (1<<PB3)
#define	ClrKB	PORTB &= ~(1<<PB3)


#define	KEYSTART	(PIND & (1<<PD2))
#define	KEYMODE		(PIND & (1<<PD3))



typedef struct{
 byte r;
 byte g;
 byte b;
 byte onoff;
}kolor;


kolor Kolory[7]; 					// Aktualnie wywietlane kolory na kostce
kolor defKol1;						// Kolor kostki 1
kolor defKol2;						// Kolor kostki 2
kolor defKolRGB[7];					// Kolor kostki z rznokolorowymi oczkami


int _rand(unsigned int zakres);
byte LosujLiczbe();
void Dekoduj(byte liczba);
word volatile overtime = CZAS_IDLE;
word volatile powedowntime = CZAS_POWDWN;
word volatile wys2kolory = CZAS_2KOLORY;
#define	LCOLOR	32		// Liczba kolorw
#define	SHIFTCOL 3		// Przeunicie bitw koloru
void SetColor();
void SetColor2();
void Wygas();
enum {/*-- tryby jednokolorowe ---*/					// *TRYBY! (zmiany w kilku miejscach!)
	  MODE_1JULIA,
	  MODE_1B, MODE_1G, MODE_1R, MODE_1Y, MODE_1W,
	  /*-- tryby dwukolorowe ---*/
	  MODE_2GR,
	  MODE_2BR,
	  MODE_2BG,
	  MODE_2YG,
	  MODE_2BW,
	  MODE_2BY,
	MODE_END,
	  /*-- tryby wyczone ---*/
	  MODE_2RG,
	  MODE_2RB,
	  MODE_2GB,
	  MODE_MULTIKOLOR
	};
byte mode NOINIT;
unsigned long lfsr NOINIT;
void PrintMode();
void SetPio();



struct				// pole bitowe:
{
byte Mode : 1;
byte f2 : 1;
byte f3 : 2;
byte f4 : 1;
byte f5 : 1;
byte f6 : 1;
byte f7 : 1;
byte f8 : 1;

byte f9 : 1;
} FL;
/*
uycie:
 flagi.f1 = 1;
 flagi.f1 = flagi.f2
 if ( flagi.f2=0 )
 switch( flagi.f2=0 )
 while( flagi.f2=0 )

gdy zadeklarowany:
 byte f3 : 2;
to:
 flagi.f3 = 2;
 flagi.f3 = 3;
 flagi.f3 = 0;
*/




/*
//------------------------------------------------------------------//
//				Sekcja ".initX"	(ZERO zainicjalizowane)				//
//------------------------------------------------------------------//
unsigned char DnoStosu NOINIT;			// Kontrola stosu
void ClrIntRam(void) __attribute__ ((naked)) __attribute__ ((section (".init3")));
void ClrIntRam(void)
{
unsigned char *AdrRam;
	//--- Zapisujemy od ostatniej zajetej komrki ram do wierzchoka stosu -32 bajty rezerwy ---
	for (AdrRam=&DnoStosu; AdrRam < (unsigned char*)RAMEND-32; AdrRam++)			// Wpisanie do IntRam $FF
		{
		*AdrRam = 0xFF;
		}
}
*/



/*
#ifdef CPULOCK
__attribute__((section (".lock"))) const unsigned char __lock =
0xFC;
#else
	#warning "Nie ustawione LockBits"
#endif
*/




#if defined(__AVR_ATmega88__) || defined(__AVR_ATmega88P__) 
__fuse_t __fuse __attribute__((section (".fuse"))) =
{
	.extended = 0xF9,
	.high = 0xDD,
	.low = 0xC2,
};
#else
	#error "Nie ustawione FuseBits"
#endif





byte FlPowerOn NOINIT;


byte EEcfg EEMEM = 0xCA;				// Zapamietanie w eeprom wartoci $dc
byte EEmode EEMEM = MODE_1B;



/********************************************************************************/
/*																				*/
/********************************************************************************/
int main()
{
byte x=0, y, c, nrkostki=0, w1=0, w2=0, wOld=0;
byte toczy_sie=0;
byte cSREG;


	FL.Mode = FALSE;


	SetPio();					//----- Ustawienie wyj -----//


	TCCR1B = 0x01;										// Preskaler na 1 ~ 8000000/1/256 = 31,256Hz
	TIMSK1 =  ( 1<<TOIE1 );								// Zezwolenie na IRQ od przepelnienia timera 1


	//--- Wycz zbdne peryferia ---//
	power_adc_disable();
	power_spi_disable();
	power_timer0_disable();
	power_timer2_disable();
	power_twi_disable();
	power_usart0_disable();


	sei();


	for(c=0; c<6; c++)
		{
		Dekoduj( c );
		for(x=0; x<255 ;x++)
			{
			for(y=0; y<7; y++)
				{
				switch( c )
					{
					case( 0 ):
						Kolory[y].r=0;
						Kolory[y].g=x;
						Kolory[y].b=x;
						break;
					case( 1 ):
						Kolory[y].r=x;
						Kolory[y].g=x;
						Kolory[y].b=0;
						break;
					case( 2 ):
						Kolory[y].r=x;
						Kolory[y].g=0;
						Kolory[y].b=x;
						break;
					case( 3 ):
						Kolory[y].r=0;
						Kolory[y].g=0;
						Kolory[y].b=x;
						break;
					case( 4 ):
						Kolory[y].r=0;
						Kolory[y].g=x;
						Kolory[y].b=0;
						break;
					case( 5 ):
						Kolory[y].r=x;
						Kolory[y].g=0;
						Kolory[y].b=0;
						break;
					}
				}
			_delay_ms(1);
			if (KEYSTART==0)goto koniec_dema;
			// if (KEYMODE==0)goto koniec_dema;
			}
		}
	_delay_ms(1000);
koniec_dema:


	mode = eeprom_read_byte( &EEmode );			// Odczyt trybu pracy
	if (mode >= MODE_END){ mode = 0; };



	//---------------------------------------//
	//-				Ptla gwna			-//
	//---------------------------------------//
	FL.Mode = FALSE;							// Wyjd ztrybu ustawiania trybu pracy (jesli w nim by)
	SetColor();									// Ustaw kolory zaleznie od trybu
	Dekoduj( 5 );
	overtime = CZAS_IDLE;


	while(1)
		{
start:
		if (KEYSTART==0)									// Jeli przycisk losowania nacinity
			{						//--- Przycisk losowania nacinity ---//
			FL.Mode = FALSE;							// Wyjd ztrybu ustawiania trybu pracy (jesli w nim by)
			SetColor();										// Ustaw kolory zaleznie od trybu
			w2 = LosujLiczbe();								// Wynik dla losowania drugiej kostki
			Dekoduj( w1 = wOld = LosujLiczbe() );			// Wynik dla pierwszej kostki
			overtime = CZAS_IDLE;
			toczy_sie = (LosujLiczbe() & 3) + 3;			// Ile jeszcze kostka ma si "potoczy"
			}
		else						//--- Przycisk losowania zwolniony ---//
			{
			if (FL.Mode == FALSE)						// Jeli nie jest w trybie ustawiania trybu pracy
				{
				if (toczy_sie != 0)								// Jeli kostkla nie skoczya sie toczy
					{
					toczy_sie--;
					w1 = LosujLiczbe();							// dodatkowe losowania
					while ( wOld == w1 )						// Jeli wyniki dwch ostatnich losowa takie same
						{
						w1 = LosujLiczbe();						// Losuj ponownie
						}
					wOld = w1;									// Zapamitaj wynik losowania
					Dekoduj( w1 );
					_delay_ms( 200);
					}
				else if (toczy_sie == 1)						// Czy ostatni "obrt" kostki
					{					//--- Ostatni obrt kostki ---//
					overtime = CZAS_IDLE;
					nrkostki=1;
					wys2kolory = CZAS_2KOLORY;
					}
				else if (toczy_sie == 0 )						// Czy kostka skoczya sie toczy?
					{					//--- Kosta zatrzymaa si ---//
					// W trybie jeden kolor "wyrzucone oczka s juz widoczne na wywietlaczu
					if ( (mode==MODE_2RG) ||			// Jeli tryb kostki 2 kolory
						 (mode==MODE_2GR) ||			// *TRYBY! (zmiany w kilku miejscach!)
						 (mode==MODE_2RB) ||
						 (mode==MODE_2BR) ||
						 (mode==MODE_2GB) ||
						 (mode==MODE_2BG) ||						 
						 (mode==MODE_2YG) ||
						 (mode==MODE_2BW) ||
						 (mode==MODE_2BY)
						)
						 	{
							if (wys2kolory == 0)					// Jeli czas zmienic wywietlana kostk
								{
								wys2kolory = CZAS_2KOLORY;
								nrkostki++;
								if ( (nrkostki & 1) == 0 )	 		// Naprzemienne wywietlanie wyniku
									{
									SetColor();
									Dekoduj( w1 );
									}
								else
									{
									SetColor2();
									Dekoduj( w2 );
									}
								}
							}
					}
				}
			}



		//--- Zmiana trybu pracy ---//
		if (KEYMODE==0)										// Jeli przycisk trybu nacinity
			{
			_delay_ms(50);
			if (KEYMODE==0)									// Likwidacja drenia stykw
				{
				FL.Mode = TRUE;								// Przejd w tryb ustawiania trybu pracy
				mode++;
				if (mode >= MODE_END) mode=0;
				PrintMode();
				cSREG = SREG;								// Zapamietaj stan znacznika I (przerwa)
				eeprom_write_byte( &EEmode, mode);
				SREG = cSREG;								// Odtwrz stan znacznika I (przerwa)
				_delay_ms(50);								// Likwidacja drenia stykw
				while(KEYMODE==0);							// Czekaj na zwolnienie przycisku
				}
			}



		if ( overtime == 0 )								// Jeli bezczynno
			{
			Wygas();
			if (KEYSTART==0) goto start;					// Jeli przycisk losowania nacinity
			//--- Obnizony pobr mocy ---//
			powedowntime = CZAS_POWDWN;						// Przechodzimy w obiony pobr mocy
			while(KEYSTART!=0 && KEYMODE!=0)				// Jeli start nienacinity
				{
				set_sleep_mode( SLEEP_MODE_IDLE );			// Obniony pobr mocy (przerwanie wybudzi procka)
				sleep_mode();
				if (powedowntime == 0)						// jeli czas min
					{
					//--- Sygnalizacja przejcia w upienie ---//
					SetColor();								// Ustaw kolory zaleznie od trybu
					Dekoduj( 6 );
					Wygas();
					//--- Upienie ---//
					PORTB = 0xFF;							// Wszystkie porty w stan wysoki, bo PWM tak zostaje (tryb zanegowany PWM)
					PORTC = 0xFF;
					PORTD = 0xFF;							// Nie wyczaj podciagania PD2 i PD3
					EIMSK = (1<<INT1) + (1<<INT0);			// Zezwolenie na irq od wejcia INT
					set_sleep_mode( SLEEP_MODE_PWR_DOWN );	// Upij procka
					//set_sleep_mode( SLEEP_MODE_STANDBY );	// Upij procka
					//sleep_mode();
			sleep_enable();
			sleep_cpu();
					nop();
					SetPio();								// Ustaw porty DDRx
					SetColor();								// Ustaw kolory zaleznie od trybu
					overtime = CZAS_IDLE;
					}
				}
			}
		}


}



//----------------------------------------------------------------------//
//					Ustaw porty DDRx									//
//----------------------------------------------------------------------//
void SetPio()
{
	//----- Ustawienie wyj -----//
	DDRB = 0xFF;
	DDRC = 0xFF;
	DDRD = 0xF3;			// Tylko PD2 i PD3 wejciami, reszta wyjcia
	PORTD= 0x0C;			// PD2 i 3 z podciganiem
}



//----------------------------------------------------------------------//
//					Pynne wygaszenie									//
//----------------------------------------------------------------------//
void Wygas()
{
byte x, y;


	for(x=0; x<255; x++)							// Pynne wygaszenie LED-w
		{
		for(y=0; y<7; y++)
			{
			if (Kolory[y].r != 0) Kolory[y].r -= 1;
			if (Kolory[y].g != 0) Kolory[y].g -= 1;
			if (Kolory[y].b != 0) Kolory[y].b -= 1;
			}
		_delay_ms(2);
		if (KEYSTART==0) return;					// Jeli przycisk losowania nacinity
		}
}



//----------------------------------------------------------------------//
//					Wywietla tryb pracy								//
//----------------------------------------------------------------------//
void PrintMode()
{
	SetColor();


	if ( (mode==MODE_1JULIA) ||					// *TRYBY! (zmiany w kilku miejscach!)
		 (mode==MODE_1R) ||
		 (mode==MODE_1G) ||
		 (mode==MODE_1B) ||
		 (mode==MODE_1Y) ||
		 (mode==MODE_1W) )
		 	{
			Kolory[0].onoff = 0;
			Kolory[1].onoff = 0;
			Kolory[2].onoff = 0;
			Kolory[3].onoff = 0;
			Kolory[4].onoff = 1;
			Kolory[5].onoff = 1;
			Kolory[6].onoff = 1;
			}


	if ( (mode==MODE_2RG) ||
		 (mode==MODE_2GR) ||
		 (mode==MODE_2RB) ||
		 (mode==MODE_2BR) ||
		 (mode==MODE_2GB) ||
		 (mode==MODE_2BG) ||
		 (mode==MODE_2YG) ||
		 (mode==MODE_2BW) ||
		 (mode==MODE_2BY) )
		 	{
			Kolory[0].onoff = 1;
			Kolory[1].onoff = 1;
			Kolory[2].onoff = 1;
			Kolory[3].onoff = 0;
			Kolory[4].onoff = 1;
			Kolory[5].onoff = 1;
			Kolory[6].onoff = 1;
			Kolory[0] = defKol2;		// Drugi kolor
			Kolory[1] = defKol2;
			Kolory[2] = defKol2;
			}

#ifdef MODE_MULTIKOLOR
	if (mode==MODE_MULTIKOLOR)			// Jeli tryb multikolor
		{

//defKolRGB[].r


		}
#endif

}



//----------------------------------------------------------------------//
//					Ustawia kolor zalenie od trybu pracy				//
// Uwaga! Kasuje "onoff", wywoywac wic przed "Dekoduj()"				//
//----------------------------------------------------------------------//
void SetColor()
{
	switch(mode)							// *TRYBY! (zmiany w kilku miejscach!)
		{
		case( MODE_1JULIA ):
			defKol1.r = 255;
			defKol1.g = 0;
			defKol1.b = 255;
			break;
		case( MODE_1R ):
			defKol1.r = 255;
			defKol1.g = 0;
			defKol1.b = 0;
			break;
		case( MODE_1G ):
			defKol1.r = 0;
			defKol1.g = 255;
			defKol1.b = 0;
			break;
		case( MODE_1B ):
			defKol1.r = 0;
			defKol1.g = 0;
			defKol1.b = 255;
			break;
		case( MODE_1Y ):
			defKol1.r = 0;
			defKol1.g = 255;
			defKol1.b = 255;
			break;
		case( MODE_1W ):
			defKol1.r = 255;
			defKol1.g = 255;
			defKol1.b = 255;
			break;
		case( MODE_2RG ):
			defKol1.r = 255;
			defKol1.g = 0;
			defKol1.b = 0;
			defKol2.r = 0;
			defKol2.g = 255;
			defKol2.b = 0;
			break;
		case( MODE_2GR ):
			defKol1.r = 0;
			defKol1.g = 255;
			defKol1.b = 0;
			defKol2.r = 255;
			defKol2.g = 0;
			defKol2.b = 0;
			break;
		case( MODE_2RB ):
			defKol1.r = 255;
			defKol1.g = 0;
			defKol1.b = 0;
			defKol2.r = 0;
			defKol2.g = 0;
			defKol2.b = 255;
			break;
		case( MODE_2BR ):
			defKol1.r = 0;
			defKol1.g = 0;
			defKol1.b = 255;
			defKol2.r = 255;
			defKol2.g = 0;
			defKol2.b = 0;
			break;
		case( MODE_2GB):
			defKol1.r = 0;
			defKol1.g = 255;
			defKol1.b = 0;
			defKol2.r = 0;
			defKol2.g = 0;
			defKol2.b = 255;
			break;
		case( MODE_2BG):
			defKol1.r = 0;
			defKol1.g = 0;
			defKol1.b = 255;
			defKol2.r = 0;
			defKol2.g = 255;
			defKol2.b = 0;
			break;
		case( MODE_2YG):
			defKol1.r = 0;
			defKol1.g = 255;
			defKol1.b = 0;
			defKol2.r = 255;
			defKol2.g = 0;
			defKol2.b = 255;
			break;
		case( MODE_2BW):
			defKol1.r = 0;
			defKol1.g = 0;
			defKol1.b = 255;
			defKol2.r = 255;
			defKol2.g = 255;
			defKol2.b = 255;
			break;
		case( MODE_2BY):
			defKol1.r = 0;
			defKol1.g = 0;
			defKol1.b = 255;
			defKol2.r = 0;
			defKol2.g = 255;
			defKol2.b = 255;
			break;
		}

	defKol1.onoff = 1;
	defKol2.onoff = 1;


	Kolory[0] = defKol1;		// Ustaw pierwszy kolor na wywietlaczu
	Kolory[1] = defKol1;
	Kolory[2] = defKol1;
	Kolory[3] = defKol1;
	Kolory[4] = defKol1;
	Kolory[5] = defKol1;
	Kolory[6] = defKol1;
}



//----------------------------------------------------------------------//
//					Ustawia kolor nr 2									//
// Uwaga! Kasuje "onoff", wywoywac wic przed "Dekoduj()"				//
//----------------------------------------------------------------------//
void SetColor2()
{
	Kolory[0] = defKol2;		// Ustaw drgi kolor na wywietlaczu
	Kolory[1] = defKol2;
	Kolory[2] = defKol2;
	Kolory[3] = defKol2;
	Kolory[4] = defKol2;
	Kolory[5] = defKol2;
	Kolory[6] = defKol2;
}



//----------------------------------------------------------------------//
//					Przerwanie od wejcia INT 0							//
//----------------------------------------------------------------------//
INTERRUPT( INT0_vect )
{
	EIMSK = 0;										// Wycz zezwolenie na irq od wejcia INT
}



//----------------------------------------------------------------------//
//					Przerwanie od wejcia INT 1							//
//----------------------------------------------------------------------//
INTERRUPT( INT1_vect )
{
	EIMSK = 0;										// Wycz zezwolenie na irq od wejcia INT
}



//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 1								//
//----------------------------------------------------------------------//
INTERRUPT( TIMER1_OVF_vect )
{
static byte cnt=0, pwm=0, pwmR, pwmG, pwmB;



	TCNT1 = 65535-256;


	if (pwm==LCOLOR)
		{
		pwm=0;
		//--- Zaadowanie nowych kolorw i warotci PWM-a ---//
		switch(cnt)		// Ustaw odpowiedni anod
			{
			case(0): SetA0; ClrA1; ClrA2; ClrA3; ClrA4; ClrA5; ClrA6; break;	// Led nr 0 (przesunnicie, bo zapis PWM zostanie wygenerowany dopiero w nastpnym cyklu
			case(1): ClrA0; SetA1; ClrA2; ClrA3; ClrA4; ClrA5; ClrA6; break;	// Led nr 1
			case(2): ClrA0; ClrA1; SetA2; ClrA3; ClrA4; ClrA5; ClrA6; break;
			case(3): ClrA0; ClrA1; ClrA2; SetA3; ClrA4; ClrA5; ClrA6; break;
			case(4): ClrA0; ClrA1; ClrA2; ClrA3; SetA4; ClrA5; ClrA6; break;
			case(5): ClrA0; ClrA1; ClrA2; ClrA3; ClrA4; SetA5; ClrA6; break;
			case(6): ClrA0; ClrA1; ClrA2; ClrA3; ClrA4; ClrA5; SetA6; break;
			}


		if ( Kolory[cnt].onoff != 0 )			// Jeli led ma wieci
			{
			pwmR = Kolory[cnt].r >> SHIFTCOL;	// Ustaw PWM (przeswamy o 3 bity, bo PWM ma 32 poziomy, a nie 256)
			pwmG = Kolory[cnt].g >> SHIFTCOL;
			pwmB = Kolory[cnt].b >> SHIFTCOL;
			}
		else									// Jesli zgaszony
			{
			pwmR = 0;							// Wyacz PWM
			pwmG = 0;
			pwmB = 0;
			}


		//--- Ustaw nastpny LED ---//
		cnt++;
		if (cnt==7)
			{
			cnt=0;
			if (overtime!=0)overtime--;			// Odliczanie czasu
			if (powedowntime!=0)powedowntime--;
			if (wys2kolory!=0)wys2kolory--;
			}
		}


	//--- Programowy PWM ---//
	//    Jest na kocu, dzieki czemu nie ma lekkiego swiecenia LED-w gdy pwmX=0
	if (pwm==0)
		{
		if (pwmR!=0)ClrKR;
		if (pwmG!=0)ClrKG;
		if (pwmB!=0)ClrKB;
		}
	if (pwmR==pwm) SetKR;
	if (pwmG==pwm) SetKG;
	if (pwmB==pwm) SetKB;


	//--- Next takt PWM-a ---//
	pwm++;
}



//------------------------------------------------------------------------------//
// 				Dekodowanie liczby na oczka										//
// Uwaga! Wczeniej wywoa "Setcolor()" lub "Setcolor2()"						//
//------------------------------------------------------------------------------//
void Dekoduj(byte liczba)
{
	switch( liczba )
		{
		case( 0 ):						// Jewietl 1
			Kolory[0].onoff = 0;
			Kolory[1].onoff = 0;
			Kolory[2].onoff = 0;
			Kolory[3].onoff = 1;
			Kolory[4].onoff = 0;
			Kolory[5].onoff = 0;
			Kolory[6].onoff = 0;
			break;
		case( 1 ):						// Jewietl 2
			Kolory[0].onoff = 0;
			Kolory[1].onoff = 0;
			Kolory[2].onoff = 1;
			Kolory[3].onoff = 0;
			Kolory[4].onoff = 1;
			Kolory[5].onoff = 0;
			Kolory[6].onoff = 0;
			break;
		case( 2 ):						// Jewietl 3
			Kolory[0].onoff = 0;
			Kolory[1].onoff = 0;
			Kolory[2].onoff = 1;
			Kolory[3].onoff = 1;
			Kolory[4].onoff = 1;
			Kolory[5].onoff = 0;
			Kolory[6].onoff = 0;
			break;
		case( 3 ):						// Jewietl 4
			Kolory[0].onoff = 1;
			Kolory[1].onoff = 0;
			Kolory[2].onoff = 1;
			Kolory[3].onoff = 0;
			Kolory[4].onoff = 1;
			Kolory[5].onoff = 0;
			Kolory[6].onoff = 1;
			break;
		case( 4 ):						// Jewietl 5
			Kolory[0].onoff = 1;
			Kolory[1].onoff = 0;
			Kolory[2].onoff = 1;
			Kolory[3].onoff = 1;
			Kolory[4].onoff = 1;
			Kolory[5].onoff = 0;
			Kolory[6].onoff = 1;
			break;
		case( 5 ):						// Jewietl 6
			Kolory[0].onoff = 1;
			Kolory[1].onoff = 1;
			Kolory[2].onoff = 1;
			Kolory[3].onoff = 0;
			Kolory[4].onoff = 1;
			Kolory[5].onoff = 1;
			Kolory[6].onoff = 1;
			break;
		case( 6 ):						// Wszystko zawioeconw
			Kolory[0].onoff = 1;
			Kolory[1].onoff = 1;
			Kolory[2].onoff = 1;
			Kolory[3].onoff = 1;
			Kolory[4].onoff = 1;
			Kolory[5].onoff = 1;
			Kolory[6].onoff = 1;
			break;
		}
}



//-----------------------------------------------------------------------------
// 				Losowanie liczny z zakresu 0..5
//-----------------------------------------------------------------------------
byte LosujLiczbe()
{
byte wynik;


	while (1)
		{
		wynik = _rand(255) & 7;		// Losuj z zakresu 0..7
		if ( wynik <= 5 )			// Jeli liczba z zakresu 0..5
			{
			return( wynik );		// Wyjd z petli
			}
		}

return( 0xFF );
}



//-----------------------------------------------------------------------------
// Generuje liczbe pseudolosowa
//-----------------------------------------------------------------------------
int _rand(unsigned int zakres)
{
	if (lfsr == 0) lfsr = 1;			// Rejestr nie moze by zerem

    lfsr = (lfsr >> 1) ^ (-(lfsr & 1) & 0xd0000001);
	return( lfsr );
}



